//gcc -Wall -g -o CopyFile CopyFile.C -lstdc++

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>



typedef struct
{
	uint16_t 	ImageFileType ;         /* Always 4D42h (''BM'')                    */
	uint32_t 	FileSize ;              /* Physical file size in bytes              */
	uint16_t	Reserved1 ;
	uint16_t	Reserved2 ;
	uint32_t	ImageDataOffset ;       /* Start of image data offset in byte       */
}__attribute__((__packed__)) BITMAP_HEADER1 ;

typedef struct
{
	uint16_t 	HeaderSize ;            /* Size of this header                      */
	uint16_t	Reserved1;
	uint16_t	ImageWidth ;            /* Image width in pixel                     */
	uint16_t	Reserved2;
	uint16_t	ImageHeight ;           /* Image height in pixel                    */
	uint16_t	Reserved3;
	uint16_t	NumberOfImagePlanes ;   /* always 1                                 */
	uint16_t	BitPerPixel ;           /* 1, 4, 8, 24                              */
	uint32_t	CompressionMethod ;     /* 0, 1, 2                                  */
	uint32_t	SizeOfBitmap ;          /* Size of the bitmap in bytes              */
	uint32_t	HorzResolution ;        /* Horiz. Resolution in pixel per meter     */
	uint32_t	VertResolution ;        /* Vert. Resolution in pixel per meter      */
	uint32_t	NumColorsUsed ;         /* Number of the colors in the bitmap       */
	uint32_t	NumSignificantColors ;	/* Number of important colors in palette	  */
}__attribute__((__packed__)) 	BITMAP_HEADER2 ;

typedef struct
{
	uint8_t 	Blue ;
	uint8_t		Green ;
	uint8_t		Red ;
}__attribute__((__packed__))	RGB ;


#define BUF_SIZE   1024

static void copy1 (const char *pSrc, const char *pDst);
static void copy2 (const char *pSrc, const char *pDst);


int main(void)
{
    copy1 ("icon.bmp", "icon1.bmp");
    copy2 ("icon.bmp", "icon2.bmp");

    return 0;
}







static void copy1 (const char *pSrc, const char *pDst)
{
    FILE          *p1;               // Source file
    FILE          *p2;               // Destination file
    unsigned char *p_buffer;         
    int            nbByte;

    /* Open the files */
    p1 = fopen(pSrc, "rb");
    p2 = fopen(pDst, "wb");

    // dynamic allocation
    p_buffer = new unsigned char[BUF_SIZE];



    // Copy RGB data
    for ( ; !feof(p1); )
    {
        nbByte=fread(p_buffer, 1, BUF_SIZE, p1);
        fwrite(p_buffer, 1, nbByte, p2);
    }


    // free dynamic allocation
    delete [] p_buffer;

    // Close files
    fclose(p1);
    fclose(p2);
}



static void copy2 (const char *pSrc, const char *pDst)
{
    FILE          *p1;               // Source file
    FILE          *p2;               // Destination file
    unsigned char *p_buffer; 
    int            nbByte;

    /* Open the files */
    p1 = fopen(pSrc, "rb");
    p2 = fopen(pDst, "wb");



    // dynamic allocation
    p_buffer = new unsigned char[BUF_SIZE];



    // Copy RGB data
    for ( ; (nbByte=fread(p_buffer, 1, BUF_SIZE, p1)) != 0; )
    {
        fwrite(p_buffer, 1, nbByte, p2);
    }


    // free dynamic allocation
    delete [] p_buffer;

    // Close files
    fclose(p1);
    fclose(p2);
}




